// JCL_DEBUG_EXPERT_INSERTJDBG ON
program SASPlanet;

uses
  {$IFDEF RELEASE}
  FastMM4,
  {$ENDIF}
  Forms,
  Windows,
  SysUtils,
  MidasLib,
  XPMan,
  u_ReadableThreadNames,
  i_GlobalBerkeleyDBHelper in 'TileStorage\BerkeleyDB\i_GlobalBerkeleyDBHelper.pas',
  u_GlobalBerkeleyDBHelper in 'TileStorage\BerkeleyDB\u_GlobalBerkeleyDBHelper.pas',
  u_BerkeleyDB in 'TileStorage\BerkeleyDB\u_BerkeleyDB.pas',
  u_BerkeleyDBEnv in 'TileStorage\BerkeleyDB\u_BerkeleyDBEnv.pas',
  u_BerkeleyDBKey in 'TileStorage\BerkeleyDB\u_BerkeleyDBKey.pas',
  u_BerkeleyDBPool in 'TileStorage\BerkeleyDB\u_BerkeleyDBPool.pas',
  u_BerkeleyDBValue in 'TileStorage\BerkeleyDB\u_BerkeleyDBValue.pas',
  i_BerkeleyDBKeyValue in 'TileStorage\BerkeleyDB\i_BerkeleyDBKeyValue.pas',
  u_TileFileNameBerkeleyDB in 'TileStorage\BerkeleyDB\u_TileFileNameBerkeleyDB.pas',
  u_TileStorageBerkeleyDB in 'TileStorage\BerkeleyDB\u_TileStorageBerkeleyDB.pas',
  u_TileStorageBerkeleyDBHelper in 'TileStorage\BerkeleyDB\u_TileStorageBerkeleyDBHelper.pas',
  u_TileStorageTypeBerkeleyDB in 'TileStorage\BerkeleyDB\u_TileStorageTypeBerkeleyDB.pas',
  u_EnumTileInfoByBerkeleyDB in 'TileStorage\BerkeleyDB\u_EnumTileInfoByBerkeleyDB.pas',
  u_BinaryDataByBerkeleyDBValue in 'TileStorage\BerkeleyDB\u_BinaryDataByBerkeleyDBValue.pas',
  u_BerkeleyDBFactory in 'TileStorage\BerkeleyDB\u_BerkeleyDBFactory.pas',
  i_BerkeleyDBFactory in 'TileStorage\BerkeleyDB\i_BerkeleyDBFactory.pas',
  i_BerkeleyDBEnv in 'TileStorage\BerkeleyDB\i_BerkeleyDBEnv.pas',
  i_BerkeleyDB in 'TileStorage\BerkeleyDB\i_BerkeleyDB.pas',
  i_BerkeleyDBPool in 'TileStorage\BerkeleyDB\i_BerkeleyDBPool.pas',
  u_TileStorageInRAM in 'TileStorage\RAM\u_TileStorageInRAM.pas',
  u_TileStorageTypeInRAM in 'TileStorage\RAM\u_TileStorageTypeInRAM.pas',
  i_StorageTypeAbilities in 'TileStorage\i_StorageTypeAbilities.pas',
  i_SimpleTileStorageConfig in 'TileStorage\i_SimpleTileStorageConfig.pas',
  i_StorageState in 'TileStorage\i_StorageState.pas',
  i_StorageStateInternal in 'TileStorage\i_StorageStateInternal.pas',
  i_StorageStateProxy in 'TileStorage\i_StorageStateProxy.pas',
  u_StorageStateStatic in 'TileStorage\u_StorageStateStatic.pas',
  u_SimpleTileStorageConfig in 'TileStorage\u_SimpleTileStorageConfig.pas',
  u_SimpleTileStorageConfigStatic in 'TileStorage\u_SimpleTileStorageConfigStatic.pas',
  u_StorageStateInternal in 'TileStorage\u_StorageStateInternal.pas',
  u_StorageStateProxy in 'TileStorage\u_StorageStateProxy.pas',
  i_TileInfoBasicMemCache in 'i_TileInfoBasicMemCache.pas',
  i_Synchronizer in 'Synchronize\i_Synchronizer.pas',
  i_ReadWriteSyncFactory in 'Synchronize\i_ReadWriteSyncFactory.pas',
  u_ReadWriteSyncAbstract in 'Synchronize\u_ReadWriteSyncAbstract.pas',
  u_ReadWriteSyncCriticalSection in 'Synchronize\u_ReadWriteSyncCriticalSection.pas',
  u_ReadWriteSyncRtlResource in 'Synchronize\u_ReadWriteSyncRtlResource.pas',
  u_ReadWriteSyncSRW in 'Synchronize\u_ReadWriteSyncSRW.pas',
  u_SynchronizerBase in 'Synchronize\u_SynchronizerBase.pas',
  u_SynchronizerSimple in 'Synchronize\u_SynchronizerSimple.pas',
  u_BaseInterfacedObject in 'u_BaseInterfacedObject.pas',
  i_ArchiveReadWrite in 'ArchiveReadWrite\i_ArchiveReadWrite.pas',
  u_ArchiveReadWriteKaZip in 'ArchiveReadWrite\u_ArchiveReadWriteKaZip.pas',
  u_ArchiveWriteLibTar in 'ArchiveReadWrite\u_ArchiveWriteLibTar.pas',
  u_ArchiveReadWrite7Zip in 'ArchiveReadWrite\u_ArchiveReadWrite7Zip.pas',
  i_ArchiveReadWriteFactory in 'ArchiveReadWrite\i_ArchiveReadWriteFactory.pas',
  u_ArchiveReadWriteFactory in 'ArchiveReadWrite\u_ArchiveReadWriteFactory.pas',
  u_ZmpFileNamesIteratorFactory in 'u_ZmpFileNamesIteratorFactory.pas',
  i_Listener in 'i_Listener.pas',
  i_Notifier in 'i_Notifier.pas',
  i_NotifierFactory in 'i_NotifierFactory.pas',
  u_Notifier in 'u_Notifier.pas',
  u_NotifierFactorySimple in 'u_NotifierFactorySimple.pas',
  i_NotifierOperation in 'i_NotifierOperation.pas',
  u_NotifierOperation in 'u_NotifierOperation.pas',
  i_ListenerTime in 'i_ListenerTime.pas',
  u_ListenerTime in 'u_ListenerTime.pas',
  i_NotifierTime in 'i_NotifierTime.pas',
  u_NotifierTime in 'u_NotifierTime.pas',
  u_ListenerByEvent in 'u_ListenerByEvent.pas',
  u_NotifyWithGUIDEvent in 'u_NotifyWithGUIDEvent.pas',
  i_ListenerNotifierLinksList in 'i_ListenerNotifierLinksList.pas',
  u_ListenerNotifierLinksList in 'u_ListenerNotifierLinksList.pas',
  c_SasVersion in 'c_SasVersion.pas',
  c_InternalBrowser in 'c_InternalBrowser.pas',
  c_CoordConverter in 'c_CoordConverter.pas',
  c_SensorsGUIDSimple in 'c_SensorsGUIDSimple.pas',
  t_GeoTypes in 't_GeoTypes.pas',
  t_CommonTypes in 't_CommonTypes.pas',
  t_FillingMapModes in 't_FillingMapModes.pas',
  i_GUIDListStatic in 'i_GUIDListStatic.pas',
  u_GUIDListStatic in 'u_GUIDListStatic.pas',
  u_HashCacheWithQueuesAbstract in 'u_HashCacheWithQueuesAbstract.pas',
  u_StreamReadOnlyByBinaryData in 'u_StreamReadOnlyByBinaryData.pas',
  i_StringListStatic in 'i_StringListStatic.pas',
  u_StringListStatic in 'u_StringListStatic.pas',
  i_HashFunction in 'i_HashFunction.pas',
  u_HashFunctionCRC64 in 'u_HashFunctionCRC64.pas',
  i_Datum in 'i_Datum.pas',
  u_Datum in 'u_Datum.pas',
  i_SystemTimeProvider in 'i_SystemTimeProvider.pas',
  u_SystemTimeProvider in 'u_SystemTimeProvider.pas',
  u_TimeZoneInfo in 'u_TimeZoneInfo.pas',
  i_SimpleFlag in 'i_SimpleFlag.pas',
  u_SimpleFlagWithInterlock in 'u_SimpleFlagWithInterlock.pas',
  i_BinaryData in 'i_BinaryData.pas',
  u_BinaryData in 'u_BinaryData.pas',
  u_BinaryDataByMemStream in 'u_BinaryDataByMemStream.pas',
  i_BinaryDataListStatic in 'i_BinaryDataListStatic.pas',
  i_BinaryDataListChangeable in 'i_BinaryDataListChangeable.pas',
  i_PredicateByBinaryData in 'i_PredicateByBinaryData.pas',
  u_PredicateByStaticSampleList in 'u_PredicateByStaticSampleList.pas',
  u_BinaryDataListStatic in 'u_BinaryDataListStatic.pas',
  i_LonLatRect in 'i_LonLatRect.pas',
  u_LonLatRect in 'u_LonLatRect.pas',
  u_LonLatRectByPoint in 'u_LonLatRectByPoint.pas',
  i_StringProvider in 'i_StringProvider.pas',
  u_StringProviderForMapTileItem in 'u_StringProviderForMapTileItem.pas',
  u_ResStrings in 'u_ResStrings.pas',
  u_CommonFormAndFrameParents in 'u_CommonFormAndFrameParents.pas',
  u_TBXSubmenuItemWithIndicator in 'u_TBXSubmenuItemWithIndicator.pas',
  i_NotifierTilePyramidUpdate in 'i_NotifierTilePyramidUpdate.pas',
  u_NotifierTilePyramidUpdate in 'u_NotifierTilePyramidUpdate.pas',
  u_TileUpdateListenerToLonLat in 'u_TileUpdateListenerToLonLat.pas',
  i_NotifierLonLatRectUpdate in 'i_NotifierLonLatRectUpdate.pas',
  i_Rect in 'i_Rect.pas',
  i_Point in 'i_Point.pas',
  u_NotifierLonLatRectUpdate in 'u_NotifierLonLatRectUpdate.pas',
  i_NotifierRectUpdate in 'i_NotifierRectUpdate.pas',
  i_ConfigDataProvider in 'i_ConfigDataProvider.pas',
  i_ConfigDataWriteProvider in 'i_ConfigDataWriteProvider.pas',
  u_ConfigDataProviderByZip in 'u_ConfigDataProviderByZip.pas',
  u_ConfigDataProviderByIniFile in 'u_ConfigDataProviderByIniFile.pas',
  u_ConfigDataProviderByIniFileSection in 'u_ConfigDataProviderByIniFileSection.pas',
  u_ConfigDataProviderByFolder in 'u_ConfigDataProviderByFolder.pas',
  u_ConfigDataProviderByPathConfig in 'u_ConfigDataProviderByPathConfig.pas',
  u_ConfigDataProviderWithLocal in 'u_ConfigDataProviderWithLocal.pas',
  u_ConfigDataProviderVirtualWithSubItem in 'u_ConfigDataProviderVirtualWithSubItem.pas',
  u_ConfigDataProviderWithUseDepreciated in 'u_ConfigDataProviderWithUseDepreciated.pas',
  u_ConfigDataProviderWithReplacedSubItem in 'u_ConfigDataProviderWithReplacedSubItem.pas',
  u_ConfigDataProviderByResources in 'u_ConfigDataProviderByResources.pas',
  u_ConfigDataProviderWithGlobal in 'u_ConfigDataProviderWithGlobal.pas',
  u_ConfigDataProviderZmpComplex in 'u_ConfigDataProviderZmpComplex.pas',
  u_ConfigDataWriteProviderByIniFileSection in 'u_ConfigDataWriteProviderByIniFileSection.pas',
  u_ConfigDataWriteProviderByIniFile in 'u_ConfigDataWriteProviderByIniFile.pas',
  u_ConfigDataWriteProviderWithGlobal in 'u_ConfigDataWriteProviderWithGlobal.pas',
  u_SASMainConfigProvider in 'u_SASMainConfigProvider.pas',
  u_SaveLoadTBConfigByConfigProvider in 'u_SaveLoadTBConfigByConfigProvider.pas',
  u_ConfigProviderHelpers in 'u_ConfigProviderHelpers.pas',
  i_Changeable in 'i_Changeable.pas',
  u_ChangeableBase in 'u_ChangeableBase.pas',
  i_ConfigDataElement in 'i_ConfigDataElement.pas',
  u_ConfigDataElementBase in 'u_ConfigDataElementBase.pas',
  u_ConfigDataElementComplexBase in 'u_ConfigDataElementComplexBase.pas',
  i_ConfigSaveLoadStrategy in 'i_ConfigSaveLoadStrategy.pas',
  u_ConfigSaveLoadStrategyBasicUseProvider in 'u_ConfigSaveLoadStrategyBasicUseProvider.pas',
  u_ConfigSaveLoadStrategyBasicProviderSubItem in 'u_ConfigSaveLoadStrategyBasicProviderSubItem.pas',
  i_PathConfig in 'i_PathConfig.pas',
  u_PathConfig in 'u_PathConfig.pas',
  i_TileRequest in 'i_TileRequest.pas',
  u_TileRequest in 'u_TileRequest.pas',
  i_TileRequestTask in 'i_TileRequestTask.pas',
  u_TileRequestTask in 'u_TileRequestTask.pas',
  i_ErrorInfo in 'i_ErrorInfo.pas',
  i_ErrorLogger in 'i_ErrorLogger.pas',
  u_ErrorInfoSimple in 'u_ErrorInfoSimple.pas',
  i_TileError in 'i_TileError.pas',
  u_TileErrorInfo in 'u_TileErrorInfo.pas',
  i_TileErrorLogProviedrStuped in 'i_TileErrorLogProviedrStuped.pas',
  u_TileErrorLogProviedrStuped in 'u_TileErrorLogProviedrStuped.pas',
  i_PredicateByTileRequest in 'i_PredicateByTileRequest.pas',
  i_PredicateByTileInfo in 'i_PredicateByTileInfo.pas',
  u_PredicateByTileInfoBase in 'u_PredicateByTileInfoBase.pas',
  i_LogSimple in 'i_LogSimple.pas',
  i_LogSimpleProvider in 'i_LogSimpleProvider.pas',
  i_BatteryStatus in 'i_BatteryStatus.pas',
  u_BatteryStatus in 'u_BatteryStatus.pas',
  i_SimpleFactory in 'i_SimpleFactory.pas',
  u_ObjectFromPoolAbstract in 'u_ObjectFromPoolAbstract.pas',
  u_ObjectPoolBase in 'u_ObjectPoolBase.pas',
  u_ObjectFromPoolBase in 'u_ObjectFromPoolBase.pas',
  i_TileKey in 'i_TileKey.pas',
  u_TileKey in 'u_TileKey.pas',
  i_TileRect in 'i_TileRect.pas',
  u_TileRect in 'u_TileRect.pas',
  i_IdCacheSimple in 'i_IdCacheSimple.pas',
  u_IdCacheSimpleThreadSafe in 'u_IdCacheSimpleThreadSafe.pas',
  i_TileObjCache in 'i_TileObjCache.pas',
  u_MemTileCache in 'u_MemTileCache.pas',
  i_VectorItemLonLat in 'i_VectorItemLonLat.pas',
  i_VectorItemsFactory in 'i_VectorItemsFactory.pas',
  i_VectorDataFactory in 'i_VectorDataFactory.pas',
  u_VectorDataFactorySimple in 'u_VectorDataFactorySimple.pas',
  u_VectorDataFactoryForMap in 'u_VectorDataFactoryForMap.pas',
  i_HtmlToHintTextConverter in 'i_HtmlToHintTextConverter.pas',
  u_HtmlToHintTextConverterStuped in 'u_HtmlToHintTextConverterStuped.pas',
  i_ContentTypeSubst in 'i_ContentTypeSubst.pas',
  u_ContentTypeSubstByList in 'u_ContentTypeSubstByList.pas',
  i_TileMatrix in 'i_TileMatrix.pas',
  u_TileMatrixElement in 'u_TileMatrixElement.pas',
  u_TileMatrix in 'u_TileMatrix.pas',
  u_TileMatrixFactory in 'u_TileMatrixFactory.pas',
  i_AntiBan in 'i_AntiBan.pas',
  u_AntiBanStuped in 'u_AntiBanStuped.pas',
  i_DownloadResult in 'i_DownloadResult.pas',
  u_DownloadResult in 'u_DownloadResult.pas',
  i_DownloadResultFactory in 'i_DownloadResultFactory.pas',
  u_DownloadResultFactory in 'u_DownloadResultFactory.pas',
  i_DownloadChecker in 'i_DownloadChecker.pas',
  i_TileDownloadResultSaver in 'i_TileDownloadResultSaver.pas',
  u_TileDownloadResultSaverStuped in 'u_TileDownloadResultSaverStuped.pas',
  u_DownloadCheckerStuped in 'u_DownloadCheckerStuped.pas',
  i_StringListChangeable in 'i_StringListChangeable.pas',
  u_ActiveMapsLicenseList in 'u_ActiveMapsLicenseList.pas',
  i_MapTypeListChangeable in 'i_MapTypeListChangeable.pas',
  u_MapTypeListChangeableActiveBitmapLayers in 'u_MapTypeListChangeableActiveBitmapLayers.pas',
  i_ImageLineProvider in 'i_ImageLineProvider.pas',
  u_ImageLineProvider in 'u_ImageLineProvider.pas',
  i_RegionProcess in 'RegionProcess\i_RegionProcess.pas',
  i_RegionProcessProgressInfo in 'RegionProcess\i_RegionProcessProgressInfo.pas',
  u_RegionProcessProgressInfo in 'RegionProcess\u_RegionProcessProgressInfo.pas',
  i_RegionProcessProgressInfoInternalFactory in 'RegionProcess\i_RegionProcessProgressInfoInternalFactory.pas',
  u_RegionProcessProgressInfoInternalFactory in 'RegionProcess\u_RegionProcessProgressInfoInternalFactory.pas',
  i_RegionProcessProgressInfoDownload in 'RegionProcess\i_RegionProcessProgressInfoDownload.pas',
  u_RegionProcessProgressInfoDownload in 'RegionProcess\u_RegionProcessProgressInfoDownload.pas',
  u_ThreadDownloadTiles in 'RegionProcess\u_ThreadDownloadTiles.pas',
  u_ThreadMapCombineBase in 'RegionProcess\u_ThreadMapCombineBase.pas',
  u_ThreadMapCombineBMP in 'RegionProcess\u_ThreadMapCombineBMP.pas',
  u_ThreadMapCombineECW in 'RegionProcess\u_ThreadMapCombineECW.pas',
  u_ThreadMapCombineJPG in 'RegionProcess\u_ThreadMapCombineJPG.pas',
  u_ThreadMapCombineKMZ in 'RegionProcess\u_ThreadMapCombineKMZ.pas',
  u_ThreadMapCombinePNG in 'RegionProcess\u_ThreadMapCombinePNG.pas',
  u_ThreadRegionProcessAbstract in 'RegionProcess\u_ThreadRegionProcessAbstract.pas',
  u_ThreadExportAbstract in 'RegionProcess\u_ThreadExportAbstract.pas',
  u_ThreadExportEnumerator in 'RegionProcess\u_ThreadExportEnumerator.pas',
  u_ThreadExportToStorage in 'RegionProcess\u_ThreadExportToStorage.pas',
  u_ThreadExportToArchive in 'RegionProcess\u_ThreadExportToArchive.pas',
  u_ThreadExportToFileSystem in 'RegionProcess\u_ThreadExportToFileSystem.pas',
  u_ThreadExportToBerkeleyDB in 'RegionProcess\u_ThreadExportToBerkeleyDB.pas',
  u_ThreadExportIPhone in 'RegionProcess\u_ThreadExportIPhone.pas',
  u_ThreadExportToSQLite in 'RegionProcess\u_ThreadExportToSQLite.pas',
  u_ThreadExportKML in 'RegionProcess\u_ThreadExportKML.pas',
  u_ThreadExportYaMobileV3 in 'RegionProcess\u_ThreadExportYaMobileV3.pas',
  u_ThreadExportYaMobileV4 in 'RegionProcess\u_ThreadExportYaMobileV4.pas',
  u_ThreadExportToAUX in 'RegionProcess\u_ThreadExportToAUX.pas',
  u_ThreadDeleteTiles in 'RegionProcess\u_ThreadDeleteTiles.pas',
  u_ThreadGenPrevZoom in 'RegionProcess\u_ThreadGenPrevZoom.pas',
  i_Downloader in 'i_Downloader.pas',
  u_DownloaderFaked in 'u_DownloaderFaked.pas',
  u_DownloaderHttp in 'u_DownloaderHttp.pas',
  u_UiTileDownload in 'u_UiTileDownload.pas',
  u_UITileDownloadList in 'u_UITileDownloadList.pas',
  u_TileDownloaderUIOneTile in 'u_TileDownloaderUIOneTile.pas',
  u_LogForTaskThread in 'u_LogForTaskThread.pas',
  i_InternalPerformanceCounter in 'Performance\i_InternalPerformanceCounter.pas',
  u_InternalPerformanceCounterStaticData in 'Performance\u_InternalPerformanceCounterStaticData.pas',
  u_InternalPerformanceCounter in 'Performance\u_InternalPerformanceCounter.pas',
  u_InternalPerformanceCounterFake in 'Performance\u_InternalPerformanceCounterFake.pas',
  u_InternalPerformanceCounterList in 'Performance\u_InternalPerformanceCounterList.pas',
  i_InternalPerformanceCounterListForDebug in 'Performance\i_InternalPerformanceCounterListForDebug.pas',
  u_InternalPerformanceCounterListForDebugOneClass in 'Performance\u_InternalPerformanceCounterListForDebugOneClass.pas',
  u_InternalPerformanceCounterListForDebug in 'Performance\u_InternalPerformanceCounterListForDebug.pas',
  u_BaseInterfacedObjectDebug in 'u_BaseInterfacedObjectDebug.pas',
  i_DownloadRequest in 'i_DownloadRequest.pas',
  u_DownloadRequest in 'u_DownloadRequest.pas',
  i_TileDownloadRequest in 'i_TileDownloadRequest.pas',
  u_TileDownloadRequest in 'u_TileDownloadRequest.pas',
  i_TileDownloadRequestBuilderConfig in 'i_TileDownloadRequestBuilderConfig.pas',
  i_TileDownloadRequestBuilder in 'i_TileDownloadRequestBuilder.pas',
  u_TileDownloadRequestBuilderConfig in 'u_TileDownloadRequestBuilderConfig.pas',
  i_LastResponseInfo in 'i_LastResponseInfo.pas',
  u_LastResponseInfo in 'u_LastResponseInfo.pas',
  i_TilePostDownloadCropConfig in 'i_TilePostDownloadCropConfig.pas',
  u_TilePostDownloadCropConfigStatic in 'u_TilePostDownloadCropConfigStatic.pas',
  i_MapAbilitiesConfig in 'i_MapAbilitiesConfig.pas',
  u_MapAbilitiesConfigStatic in 'u_MapAbilitiesConfigStatic.pas',
  u_MapAbilitiesConfig in 'u_MapAbilitiesConfig.pas',
  i_MapAttachmentsInfo in 'i_MapAttachmentsInfo.pas',
  u_MapAttachmentsInfo in 'u_MapAttachmentsInfo.pas',
  i_MapAttachmentsFactory in 'i_MapAttachmentsFactory.pas',
  u_MapAttachmentsPascalScript in 'u_MapAttachmentsPascalScript.pas',
  i_ZmpConfig in 'i_ZmpConfig.pas',
  u_ZmpConfig in 'u_ZmpConfig.pas',
  i_ZmpInfo in 'i_ZmpInfo.pas',
  u_ZmpInfo in 'u_ZmpInfo.pas',
  i_ZmpInfoSet in 'i_ZmpInfoSet.pas',
  u_ZmpInfoSet in 'u_ZmpInfoSet.pas',
  i_ProjectionInfo in 'i_ProjectionInfo.pas',
  u_ProjectionInfo in 'u_ProjectionInfo.pas',
  i_VectorItemProjected in 'i_VectorItemProjected.pas',
  i_VectorItemLocal in 'i_VectorItemLocal.pas',
  u_VectorItemLocal in 'u_VectorItemLocal.pas',
  u_LocalSingleLine in 'u_LocalSingleLine.pas',
  u_EnumDoublePointBySingleLine in 'u_EnumDoublePointBySingleLine.pas',
  u_EnumDoublePointByLineSet in 'u_EnumDoublePointByLineSet.pas',
  u_LonLatSingleLine in 'u_LonLatSingleLine.pas',
  u_ProjectedSingleLine in 'u_ProjectedSingleLine.pas',
  u_VectorItemEmpty in 'u_VectorItemEmpty.pas',
  u_VectorItemLonLat in 'u_VectorItemLonLat.pas',
  u_VectorItemProjected in 'u_VectorItemProjected.pas',
  u_VectorItemsFactorySimple in 'u_VectorItemsFactorySimple.pas',
  i_VectorDataItemSimple in 'i_VectorDataItemSimple.pas',
  i_VectorItemSubset in 'i_VectorItemSubset.pas',
  u_VectorDataItemBase in 'u_VectorDataItemBase.pas',
  u_VectorDataItemPoint in 'u_VectorDataItemPoint.pas',
  u_VectorDataItemPolygon in 'u_VectorDataItemPolygon.pas',
  u_VectorDataItemOfMapBase in 'u_VectorDataItemOfMapBase.pas',
  u_VectorDataItemOfMapPolygon in 'u_VectorDataItemOfMapPolygon.pas',
  u_VectorDataItemOfMapPoint in 'u_VectorDataItemOfMapPoint.pas',
  u_VectorDataItemSubset in 'u_VectorDataItemSubset.pas',
  i_UseTilePrevZoomConfig in 'i_UseTilePrevZoomConfig.pas',
  u_UseTilePrevZoomConfig in 'u_UseTilePrevZoomConfig.pas',
  i_VectorItemDrawConfig in 'i_VectorItemDrawConfig.pas',
  u_VectorItemDrawConfig in 'u_VectorItemDrawConfig.pas',
  i_KmlLayerConfig in 'i_KmlLayerConfig.pas',
  u_KmlLayerConfig in 'u_KmlLayerConfig.pas',
  u_MapLayerVectorMaps in 'MapLayers\u_MapLayerVectorMaps.pas',
  i_MiniMapLayerConfig in 'i_MiniMapLayerConfig.pas',
  u_MiniMapMapsConfig in 'u_MiniMapMapsConfig.pas',
  u_MiniMapLayerConfig in 'u_MiniMapLayerConfig.pas',
  i_FullMapMouseCursorLayerConfig in 'i_FullMapMouseCursorLayerConfig.pas',
  u_FullMapMouseCursorLayerConfig in 'u_FullMapMouseCursorLayerConfig.pas',
  u_PLTSimpleParser in 'VectorLoaders\u_PLTSimpleParser.pas',
  u_GeoFun in 'u_GeoFun.pas',
  i_EnumDoublePoint in 'i_EnumDoublePoint.pas',
  i_DoublePointFilter in 'i_DoublePointFilter.pas',
  u_EnumDoublePointsByArray in 'u_EnumDoublePointsByArray.pas',
  u_EnumDoublePointFilterEqual in 'u_EnumDoublePointFilterEqual.pas',
  u_EnumDoublePointClipInternal in 'u_EnumDoublePointClipInternal.pas',
  u_EnumDoublePointWithClip in 'u_EnumDoublePointWithClip.pas',
  u_EnumDoublePointFilterFirstSegment in 'u_EnumDoublePointFilterFirstSegment.pas',
  u_EnumDoublePointClosePoly in 'u_EnumDoublePointClosePoly.pas',
  u_EnumDoublePointLonLatToMapPixel in 'u_EnumDoublePointLonLatToMapPixel.pas',
  u_EnumDoublePointMapPixelToLocalPixel in 'u_EnumDoublePointMapPixelToLocalPixel.pas',
  u_EnumDoublePointLine2Poly in 'u_EnumDoublePointLine2Poly.pas',
  i_DoublePointsAggregator in 'i_DoublePointsAggregator.pas',
  u_DoublePointsAggregator in 'u_DoublePointsAggregator.pas',
  u_GlobalState in 'u_GlobalState.pas',
  i_GlobalConfig in 'i_GlobalConfig.pas',
  u_GlobalConfig in 'u_GlobalConfig.pas',
  u_GlobalInternetState in 'u_GlobalInternetState.pas',
  u_GpsSystem in 'GPS\u_GpsSystem.pas',
  i_TextByVectorItem in 'i_TextByVectorItem.pas',
  u_TextByVectorItemHTMLByDescription in 'u_TextByVectorItemHTMLByDescription.pas',
  u_TextByVectorItemMarkInfo in 'u_TextByVectorItemMarkInfo.pas',
  i_LastSelectionInfo in 'i_LastSelectionInfo.pas',
  u_LastSelectionInfo in 'u_LastSelectionInfo.pas',
  u_LastSelectionInfoSaver in 'u_LastSelectionInfoSaver.pas',
  u_GeoToStr in 'u_GeoToStr.pas',
  i_VectorDataLoader in 'i_VectorDataLoader.pas',
  u_XmlInfoSimpleParser in 'VectorLoaders\u_XmlInfoSimpleParser.pas',
  u_KmlInfoSimpleParser in 'VectorLoaders\u_KmlInfoSimpleParser.pas',
  u_KmzInfoSimpleParser in 'VectorLoaders\u_KmzInfoSimpleParser.pas',
  u_HlgParser in 'VectorLoaders\u_HlgParser.pas',
  u_SlsParser in 'VectorLoaders\u_SlsParser.pas',
  u_MpSimpleParser in 'VectorLoaders\u_MpSimpleParser.pas',
  u_CsvParser in 'VectorLoaders\u_CsvParser.pas',
  u_MultiPoligonParser in 'u_MultiPoligonParser.pas',
  u_ImportFromArcGIS in 'u_ImportFromArcGIS.pas',
  u_ECWWrite in 'u_ECWWrite.pas',
  i_BitmapTileSaveLoad in 'BitmapTileSaveLoad\i_BitmapTileSaveLoad.pas',
  u_BitmapTileLibJpeg in 'BitmapTileSaveLoad\u_BitmapTileLibJpeg.pas',
  i_BitmapTileSaveLoadFactory in 'BitmapTileSaveLoad\i_BitmapTileSaveLoadFactory.pas',
  u_BitmapTileSaveLoadFactory in 'BitmapTileSaveLoad\u_BitmapTileSaveLoadFactory.pas',
  u_BitmapTileFreeImage in 'BitmapTileSaveLoad\u_BitmapTileFreeImage.pas',
  i_MapVersionInfo in 'i_MapVersionInfo.pas',
  u_MapVersionInfo in 'u_MapVersionInfo.pas',
  u_MapVersionFactorySimpleString in 'u_MapVersionFactorySimpleString.pas',
  i_MapVersionInfoGE in 'i_MapVersionInfoGE.pas',
  u_MapVersionFactoryGE in 'u_MapVersionFactoryGE.pas',
  u_MapVersionListStatic in 'u_MapVersionListStatic.pas',
  i_MapVersionConfig in 'i_MapVersionConfig.pas',
  u_MapVersionConfig in 'u_MapVersionConfig.pas',
  u_MapType in 'u_MapType.pas',
  u_MapTypeListStatic in 'u_MapTypeListStatic.pas',
  u_MapTypesMainList in 'u_MapTypesMainList.pas',
  i_MapTypeIconsList in 'i_MapTypeIconsList.pas',
  u_MapTypeIconsList in 'u_MapTypeIconsList.pas',
  u_ProxyConfig in 'u_ProxyConfig.pas',
  i_InetConfig in 'i_InetConfig.pas',
  u_InetConfigStatic in 'u_InetConfigStatic.pas',
  u_InetConfig in 'u_InetConfig.pas',
  i_TileDownloaderConfig in 'i_TileDownloaderConfig.pas',
  u_TileDownloaderConfigStatic in 'u_TileDownloaderConfigStatic.pas',
  u_TileDownloaderConfig in 'u_TileDownloaderConfig.pas',
  i_GSMGeoCodeConfig in 'i_GSMGeoCodeConfig.pas',
  u_GSMGeoCodeConfig in 'u_GSMGeoCodeConfig.pas',
  u_PosFromGSM in 'u_PosFromGSM.pas',
  i_DownloadInfoSimple in 'i_DownloadInfoSimple.pas',
  u_DownloadInfoSimple in 'u_DownloadInfoSimple.pas',
  i_LocalCoordConverter in 'i_LocalCoordConverter.pas',
  u_LocalCoordConverter in 'u_LocalCoordConverter.pas',
  i_LocalCoordConverterChangeable in 'i_LocalCoordConverterChangeable.pas',
  u_LocalCoordConverterChangeable in 'u_LocalCoordConverterChangeable.pas',
  u_LocalConverterChangeableFixedTileRectNoScale in 'u_LocalConverterChangeableFixedTileRectNoScale.pas',
  u_LocalConverterChangeableOfMiniMap in 'u_LocalConverterChangeableOfMiniMap.pas',
  i_LocalCoordConverterFactorySimpe in 'i_LocalCoordConverterFactorySimpe.pas',
  u_LocalCoordConverterFactorySimpe in 'u_LocalCoordConverterFactorySimpe.pas',
  i_CoordConverterList in 'i_CoordConverterList.pas',
  u_CoordConverterListStatic in 'u_CoordConverterListStatic.pas',
  u_CoordConverterListStaticSimple in 'u_CoordConverterListStaticSimple.pas',
  u_BasePascalCompiler in 'u_BasePascalCompiler.pas',
  i_InterfaceQueue in 'i_InterfaceQueue.pas',
  u_InterfaceQueue in 'u_InterfaceQueue.pas',
  u_TileDownloaderWithQueue in 'u_TileDownloaderWithQueue.pas',
  i_TileRequestProcessorPool in 'i_TileRequestProcessorPool.pas',
  u_TileRequestProcessorPool in 'u_TileRequestProcessorPool.pas',
  i_TileDownloaderList in 'i_TileDownloaderList.pas',
  u_TileDownloaderListStatic in 'u_TileDownloaderListStatic.pas',
  u_TileDownloaderList in 'u_TileDownloaderList.pas',
  u_TileDownloadRequestBuilderLazy in 'u_TileDownloadRequestBuilderLazy.pas',
  u_TileDownloadRequestBuilder in 'u_TileDownloadRequestBuilder.pas',
  u_TileDownloadRequestBuilderPascalScript in 'u_TileDownloadRequestBuilderPascalScript.pas',
  u_TileRequestBuilderHelpers in 'u_TileRequestBuilderHelpers.pas',
  i_TileRequestResult in 'i_TileRequestResult.pas',
  u_TileRequestResult in 'u_TileRequestResult.pas',
  i_TileDownloader in 'i_TileDownloader.pas',
  u_TileRequestQueueProcessorThread in 'u_TileRequestQueueProcessorThread.pas',
  u_TileDownloaderSimple in 'u_TileDownloaderSimple.pas',
  u_DownloaderHttpWithTTL in 'u_DownloaderHttpWithTTL.pas',
  i_CoordConverter in 'i_CoordConverter.pas',
  u_CoordConverterRoutines in 'u_CoordConverterRoutines.pas',
  u_CoordConverterAbstract in 'u_CoordConverterAbstract.pas',
  u_CoordConverterBasic in 'u_CoordConverterBasic.pas',
  u_CoordConverterMercatorOnEllipsoid in 'u_CoordConverterMercatorOnEllipsoid.pas',
  u_CoordConverterMercatorOnSphere in 'u_CoordConverterMercatorOnSphere.pas',
  u_CoordConverterSimpleLonLat in 'u_CoordConverterSimpleLonLat.pas',
  i_CoordConverterFactory in 'i_CoordConverterFactory.pas',
  u_CoordConverterFactorySimple in 'u_CoordConverterFactorySimple.pas',
  u_ProjectionInfoFactory in 'u_ProjectionInfoFactory.pas',
  i_ContentTypeInfo in 'i_ContentTypeInfo.pas',
  i_ContentTypeManager in 'i_ContentTypeManager.pas',
  i_ContentConverter in 'i_ContentConverter.pas',
  u_ContentTypeInfo in 'u_ContentTypeInfo.pas',
  u_ContentConverterBase in 'u_ContentConverterBase.pas',
  u_ContentConverterBitmap in 'u_ContentConverterBitmap.pas',
  u_ContentConverterKmz2Kml in 'u_ContentConverterKmz2Kml.pas',
  u_ContentConverterKml2Kmz in 'u_ContentConverterKml2Kmz.pas',
  u_ContentTypeListByKey in 'u_ContentTypeListByKey.pas',
  u_ContentTypeManagerBase in 'u_ContentTypeManagerBase.pas',
  u_ContentTypeManagerSimple in 'u_ContentTypeManagerSimple.pas',
  u_ContentConvertersListByKey in 'u_ContentConvertersListByKey.pas',
  u_ContentConverterMatrix in 'u_ContentConverterMatrix.pas',
  i_MarkPicture in 'MarksDB\i_MarkPicture.pas',
  u_MarkPictureSimple in 'MarksDB\u_MarkPictureSimple.pas',
  u_MarkPictureListSimple in 'MarksDB\u_MarkPictureListSimple.pas',
  i_TileInfoBasic in 'i_TileInfoBasic.pas',
  u_TileInfoBasic in 'u_TileInfoBasic.pas',
  u_TileInfoBasicMemCache in 'u_TileInfoBasicMemCache.pas',
  u_TileRectInfo in 'u_TileRectInfo.pas',
  u_TileRectInfoShort in 'u_TileRectInfoShort.pas',
  i_TileIterator in 'i_TileIterator.pas',
  u_TileIteratorByPolygon in 'u_TileIteratorByPolygon.pas',
  u_TileIteratorSpiralByRect in 'u_TileIteratorSpiralByRect.pas',
  u_TileIteratorByRect in 'u_TileIteratorByRect.pas',
  u_TileStorageTypeFileSystemSimple in 'TileStorage\FileSystem\u_TileStorageTypeFileSystemSimple.pas',
  i_DownloadResultTextProvider in 'i_DownloadResultTextProvider.pas',
  u_DownloadResultTextProvider in 'u_DownloadResultTextProvider.pas',
  u_GeoCodePlacemark in 'u_GeoCodePlacemark.pas',
  u_GeoCodePlacemarkWithUrlDecorator in 'u_GeoCodePlacemarkWithUrlDecorator.pas',
  u_EnumUnknown in 'u_EnumUnknown.pas',
  u_EnumUnknownTwoItems in 'u_EnumUnknownTwoItems.pas',
  i_ProxySettings in 'i_ProxySettings.pas',
  i_FindVectorItems in 'i_FindVectorItems.pas',
  i_MapViewGoto in 'i_MapViewGoto.pas',
  u_MapViewGoto in 'u_MapViewGoto.pas',
  i_GotoLayerConfig in 'i_GotoLayerConfig.pas',
  u_GotoLayerConfig in 'u_GotoLayerConfig.pas',
  i_StringHistory in 'i_StringHistory.pas',
  u_StringHistory in 'u_StringHistory.pas',
  i_SearchResultPresenter in 'i_SearchResultPresenter.pas',
  i_ThreadConfig in 'i_ThreadConfig.pas',
  u_ThreadConfig in 'u_ThreadConfig.pas',
  i_MainMapLayerConfig in 'i_MainMapLayerConfig.pas',
  u_MainMapLayerConfig in 'u_MainMapLayerConfig.pas',
  i_UsedMarksConfig in 'i_UsedMarksConfig.pas',
  u_UsedMarksConfig in 'u_UsedMarksConfig.pas',
  u_UsedMarksConfigStatic in 'u_UsedMarksConfigStatic.pas',
  i_MarksDrawConfig in 'i_MarksDrawConfig.pas',
  u_MarksDrawConfigStatic in 'u_MarksDrawConfigStatic.pas',
  u_MarksDrawConfig in 'u_MarksDrawConfig.pas',
  i_MarksLayerConfig in 'i_MarksLayerConfig.pas',
  u_MarksLayerConfig in 'u_MarksLayerConfig.pas',
  i_Category in 'i_Category.pas',
  u_Category in 'u_Category.pas',
  i_MarksSimple in 'MarksDB\i_MarksSimple.pas',
  i_MarkTemplate in 'MarksDB\i_MarkTemplate.pas',
  i_MarksDb in 'MarksDB\i_MarksDb.pas',
  i_MarkCategoryDB in 'MarksDB\i_MarkCategoryDB.pas',
  i_MarksSystem in 'MarksDB\i_MarksSystem.pas',
  u_MarksDb in 'MarksDB\SML\u_MarksDb.pas',
  u_MarkTemplates in 'MarksDB\u_MarkTemplates.pas',
  i_MarkNameGenerator in 'i_MarkNameGenerator.pas',
  u_MarkNameGenerator in 'MarksDB\u_MarkNameGenerator.pas',
  i_MarksFactoryConfig in 'MarksDB\i_MarksFactoryConfig.pas',
  u_MarksFactoryConfig in 'MarksDB\u_MarksFactoryConfig.pas',
  u_MarkTemplateConfigBase in 'MarksDB\u_MarkTemplateConfigBase.pas',
  u_MarkPolyTemplateConfig in 'MarksDB\u_MarkPolyTemplateConfig.pas',
  u_MarkPointTemplateConfig in 'MarksDB\u_MarkPointTemplateConfig.pas',
  u_MarkLineTemplateConfig in 'MarksDB\u_MarkLineTemplateConfig.pas',
  i_MarksDbSmlInternal in 'MarksDB\SML\i_MarksDbSmlInternal.pas',
  u_MarkCategoryFactorySmlDbInternal in 'MarksDB\SML\u_MarkCategoryFactorySmlDbInternal.pas',
  u_MarkCategorySmlDbInternal in 'MarksDB\SML\u_MarkCategorySmlDbInternal.pas',
  u_MarkFullBaseSml in 'MarksDB\SML\u_MarkFullBaseSml.pas',
  u_MarkPolySml in 'MarksDB\SML\u_MarkPolySml.pas',
  u_MarkPointSml in 'MarksDB\SML\u_MarkPointSml.pas',
  u_MarkLineSml in 'MarksDB\SML\u_MarkLineSml.pas',
  u_MarkFactorySmlDbInternal in 'MarksDB\SML\u_MarkFactorySmlDbInternal.pas',
  u_MarkFactory in 'MarksDB\u_MarkFactory.pas',
  i_MarkCategoryDBSmlInternal in 'MarksDB\SML\i_MarkCategoryDBSmlInternal.pas',
  u_MarkCategoryDB in 'MarksDB\SML\u_MarkCategoryDB.pas',
  u_MarkId in 'MarksDB\SML\u_MarkId.pas',
  u_MarkFullBase in 'MarksDB\u_MarkFullBase.pas',
  u_MarkPoint in 'MarksDB\u_MarkPoint.pas',
  u_MarkPoly in 'MarksDB\u_MarkPoly.pas',
  u_MarkLine in 'MarksDB\u_MarkLine.pas',
  i_MarkFactory in 'MarksDB\i_MarkFactory.pas',
  i_MarkFactorySmlInternal in 'MarksDB\SML\i_MarkFactorySmlInternal.pas',
  i_MarkCategoryFactory in 'MarksDB\i_MarkCategoryFactory.pas',
  i_MarkCategoryFactoryDbInternal in 'MarksDB\SML\i_MarkCategoryFactoryDbInternal.pas',
  u_MarkCategoryFactory in 'MarksDB\u_MarkCategoryFactory.pas',
  i_MarkCategoryFactoryConfig in 'MarksDB\i_MarkCategoryFactoryConfig.pas',
  u_MarkCategoryFactoryConfig in 'MarksDB\u_MarkCategoryFactoryConfig.pas',
  u_MarksSystem in 'MarksDB\SML\u_MarksSystem.pas',
  u_MarksDbGUIHelper in 'MarksDb\GUI\u_MarksDbGUIHelper.pas',
  i_TileProvider in 'i_TileProvider.pas',
  u_TileProviderByStorage in 'u_TileProviderByStorage.pas',
  u_TileProviderWithCache in 'u_TileProviderWithCache.pas',
  i_BitmapLayerProvider in 'i_BitmapLayerProvider.pas',
  i_BitmapLayerProviderWithListener in 'i_BitmapLayerProviderWithListener.pas',
  u_BitmapLayerProviderInPolygon in 'u_BitmapLayerProviderInPolygon.pas',
  u_BitmapLayerProviderSimpleForCombine in 'u_BitmapLayerProviderSimpleForCombine.pas',
  u_BitmapLayerProviderWithBgColor in 'u_BitmapLayerProviderWithBgColor.pas',
  u_BitmapLayerProviderByMarksSubset in 'u_BitmapLayerProviderByMarksSubset.pas',
  u_BitmapLayerProviderByVectorSubset in 'u_BitmapLayerProviderByVectorSubset.pas',
  u_BitmapLayerProviderByTrackPath in 'u_BitmapLayerProviderByTrackPath.pas',
  u_BitmapLayerProviderMapWithLayer in 'u_BitmapLayerProviderMapWithLayer.pas',
  u_BitmapLayerProviderForViewMaps in 'u_BitmapLayerProviderForViewMaps.pas',
  u_BitmapLayerProviderFillingMap in 'u_BitmapLayerProviderFillingMap.pas',
  u_BitmapLayerProviderGridTiles in 'u_BitmapLayerProviderGridTiles.pas',
  u_BitmapLayerProviderGridDegree in 'u_BitmapLayerProviderGridDegree.pas',
  u_BitmapLayerProviderGridGenshtab in 'u_BitmapLayerProviderGridGenshtab.pas',
  u_BitmapLayerProviderComplex in 'u_BitmapLayerProviderComplex.pas',
  u_WindowLayerBasic in 'MapLayers\u_WindowLayerBasic.pas',
  u_WindowLayerWithPos in 'MapLayers\u_WindowLayerWithPos.pas',
  u_TiledLayerWithThreadBase in 'MapLayers\u_TiledLayerWithThreadBase.pas',
  u_MiniMapLayer in 'MapLayers\u_MiniMapLayer.pas',
  u_MiniMapLayerTopBorder in 'MapLayers\u_MiniMapLayerTopBorder.pas',
  u_MiniMapLayerLeftBorder in 'MapLayers\u_MiniMapLayerLeftBorder.pas',
  u_MiniMapLayerPlusButton in 'MapLayers\u_MiniMapLayerPlusButton.pas',
  u_MiniMapLayerMinusButton in 'MapLayers\u_MiniMapLayerMinusButton.pas',
  u_MiniMapLayerViewRect in 'MapLayers\u_MiniMapLayerViewRect.pas',
  u_CenterScale in 'MapLayers\u_CenterScale.pas',
  u_LayerStatBar in 'MapLayers\u_LayerStatBar.pas',
  u_LayerStatBarPopupMenu in 'MapLayers\u_LayerStatBarPopupMenu.pas',
  u_FullMapMouseCursorLayer in 'MapLayers\u_FullMapMouseCursorLayer.pas',
  u_MapLayerBasic in 'MapLayers\u_MapLayerBasic.pas',
  u_MapLayerGrids in 'MapLayers\u_MapLayerGrids.pas',
  u_MapLayerMarks in 'MapLayers\u_MapLayerMarks.pas',
  u_MapLayerNavToMark in 'MapLayers\u_MapLayerNavToMark.pas',
  u_SelectionLayer in 'MapLayers\u_SelectionLayer.pas',
  u_LayerScaleLine in 'MapLayers\u_LayerScaleLine.pas',
  u_LayerScaleLinePopupMenu in 'MapLayers\u_LayerScaleLinePopupMenu.pas',
  u_MapLayerGPSTrack in 'MapLayers\u_MapLayerGPSTrack.pas',
  u_MapLayerGPSMarkerRings in 'MapLayers\u_MapLayerGPSMarkerRings.pas',
  u_MapLayerShowError in 'MapLayers\u_MapLayerShowError.pas',
  u_MapLayerGoto in 'MapLayers\u_MapLayerGoto.pas',
  u_MapLayerGPSMarker in 'MapLayers\u_MapLayerGPSMarker.pas',
  u_PolyLineLayerBase in 'MapLayers\u_PolyLineLayerBase.pas',
  u_PointOnMapEditLayer in 'MapLayers\u_PointOnMapEditLayer.pas',
  u_CalcLineLayer in 'MapLayers\u_CalcLineLayer.pas',
  u_SelectionPolylineLayer in 'MapLayers\u_SelectionPolylineLayer.pas',
  u_SelectionRectLayer in 'MapLayers\u_SelectionRectLayer.pas',
  u_LayerLicenseList in 'MapLayers\u_LayerLicenseList.pas',
  u_MapLayerBitmapMaps in 'MapLayers\u_MapLayerBitmapMaps.pas',
  c_TerrainProvider in 'Terrain\c_TerrainProvider.pas',
  i_TerrainProvider in 'Terrain\i_TerrainProvider.pas',
  u_TerrainProviderByGE in 'Terrain\u_TerrainProviderByGE.pas',
  i_TerrainStorage in 'Terrain\i_TerrainStorage.pas',
  u_GoogleEarthLibrary in 'Terrain\u_GoogleEarthLibrary.pas',
  i_GoogleEarthTerrain in 'Terrain\i_GoogleEarthTerrain.pas',
  u_TerrainProviderByGEMemCache in 'Terrain\u_TerrainProviderByGEMemCache.pas',
  u_TerrainInfo in 'Terrain\u_TerrainInfo.pas',
  i_TerrainInfo in 'Terrain\i_TerrainInfo.pas',
  i_TerrainProviderListElement in 'Terrain\i_TerrainProviderListElement.pas',
  c_TerrainProviderGUID in 'Terrain\c_TerrainProviderGUID.pas',
  u_TerrainProviderListElement in 'Terrain\u_TerrainProviderListElement.pas',
  i_TerrainProviderList in 'Terrain\i_TerrainProviderList.pas',
  u_TerrainProviderList in 'Terrain\u_TerrainProviderList.pas',
  i_TerrainConfig in 'Terrain\i_TerrainConfig.pas',
  u_TerrainConfig in 'Terrain\u_TerrainConfig.pas',
  u_ExternalTerrainAPI in 'Terrain\u_ExternalTerrainAPI.pas',
  i_ExternalTerrainsProvider in 'Terrain\i_ExternalTerrainsProvider.pas',
  u_ExternalTerrainsProvider in 'Terrain\u_ExternalTerrainsProvider.pas',
  i_Thread in 'i_Thread.pas',
  u_InterfacedThread in 'u_InterfacedThread.pas',
  i_BackgroundTask in 'i_BackgroundTask.pas',
  u_BackgroundTask in 'u_BackgroundTask.pas',
  u_MapLayerFillingMap in 'MapLayers\u_MapLayerFillingMap.pas',
  i_MarkCategory in 'MarksDB\i_MarkCategory.pas',
  u_MarkCategory in 'MarksDB\u_MarkCategory.pas',
  u_EnumUnknownEmpty in 'u_EnumUnknownEmpty.pas',
  i_ReadWriteState in 'i_ReadWriteState.pas',
  u_ReadWriteStateInternal in 'u_ReadWriteStateInternal.pas',
  i_ReadWriteStateInternal in 'i_ReadWriteStateInternal.pas',
  u_ReadWriteStateStatic in 'u_ReadWriteStateStatic.pas',
  i_TileDownloaderState in 'i_TileDownloaderState.pas',
  u_TileDownloaderStateStatic in 'u_TileDownloaderStateStatic.pas',
  u_TileDownloaderStateInternal in 'u_TileDownloaderStateInternal.pas',
  i_TileDownloadRequestBuilderFactory in 'i_TileDownloadRequestBuilderFactory.pas',
  u_TileDownloadRequestBuilderFactoryPascalScript in 'u_TileDownloadRequestBuilderFactoryPascalScript.pas',
  i_TileDownloadSubsystem in 'i_TileDownloadSubsystem.pas',
  u_TileDownloadSubsystem in 'u_TileDownloadSubsystem.pas',
  u_TileDownloadSubsystemState in 'u_TileDownloadSubsystemState.pas',
  u_TileFileNameSAS in 'TileStorage\FileSystem\u_TileFileNameSAS.pas',
  u_TileFileNameGMV in 'TileStorage\FileSystem\u_TileFileNameGMV.pas',
  u_TileFileNameES in 'TileStorage\FileSystem\u_TileFileNameES.pas',
  u_TileFileNameGM1 in 'TileStorage\FileSystem\u_TileFileNameGM1.pas',
  u_TileFileNameGM2 in 'TileStorage\FileSystem\u_TileFileNameGM2.pas',
  u_TileFileNameGM3 in 'TileStorage\FileSystem\u_TileFileNameGM3.pas',
  c_CacheTypeCodes in 'TileStorage\c_CacheTypeCodes.pas',
  i_TileFileNameGenerator in 'TileStorage\i_TileFileNameGenerator.pas',
  i_TileFileNameGeneratorsList in 'TileStorage\i_TileFileNameGeneratorsList.pas',
  i_TileFileNameParser in 'TileStorage\i_TileFileNameParser.pas',
  i_TileFileNameParsersList in 'TileStorage\i_TileFileNameParsersList.pas',
  i_TileStorage in 'TileStorage\i_TileStorage.pas',
  i_TileStorageConfig in 'TileStorage\i_TileStorageConfig.pas',
  i_TileStorageInfo in 'TileStorage\i_TileStorageInfo.pas',
  i_TileStorageType in 'TileStorage\i_TileStorageType.pas',
  i_TileStorageTypeConfig in 'TileStorage\i_TileStorageTypeConfig.pas',
  i_TileStorageTypeList in 'TileStorage\i_TileStorageTypeList.pas',
  i_TileStorageTypeListItem in 'TileStorage\i_TileStorageTypeListItem.pas',
  i_GlobalCacheConfig in 'i_GlobalCacheConfig.pas',
  u_GlobalCacheConfig in 'TileStorage\u_GlobalCacheConfig.pas',
  u_TileFileNameGeneratorsSimpleList in 'TileStorage\u_TileFileNameGeneratorsSimpleList.pas',
  u_TileFileNameParsersSimpleList in 'TileStorage\u_TileFileNameParsersSimpleList.pas',
  u_TileStorageAbstract in 'TileStorage\u_TileStorageAbstract.pas',
  u_TileStorageInfo in 'TileStorage\u_TileStorageInfo.pas',
  u_TileStorageOfMapType in 'TileStorage\u_TileStorageOfMapType.pas',
  u_TileStorageTypeAbilities in 'TileStorage\u_TileStorageTypeAbilities.pas',
  u_TileStorageTypeBase in 'TileStorage\u_TileStorageTypeBase.pas',
  u_TileStorageTypeConfig in 'TileStorage\u_TileStorageTypeConfig.pas',
  u_TileStorageTypeList in 'TileStorage\u_TileStorageTypeList.pas',
  u_TileStorageTypeListItem in 'TileStorage\u_TileStorageTypeListItem.pas',
  u_TileStorageTypeListSimple in 'TileStorage\u_TileStorageTypeListSimple.pas',
  u_TileStorageFileSystem in 'TileStorage\FileSystem\u_TileStorageFileSystem.pas',
  t_DLLCache in 'TileStorage\DLL\t_DLLCache.pas',
  u_TileStorageGE in 'TileStorage\DLL\u_TileStorageGE.pas',
  u_TileStorageGETerrain in 'TileStorage\DLL\u_TileStorageGETerrain.pas',
  u_TileStorageTypeGE in 'TileStorage\DLL\u_TileStorageTypeGE.pas',
  u_TileStorageDBMS in 'TileStorage\DBMS\u_TileStorageDBMS.pas',
  u_TileStorageTypeDBMS in 'TileStorage\DBMS\u_TileStorageTypeDBMS.pas',
  t_ETS_AuthFunc in 'TileStorage\DBMS\ExtTileStorages\t_ETS_AuthFunc.pas',
  t_ETS_AuthKind in 'TileStorage\DBMS\ExtTileStorages\t_ETS_AuthKind.pas',
  t_ETS_Path in 'TileStorage\DBMS\ExtTileStorages\t_ETS_Path.pas',
  t_ETS_Provider in 'TileStorage\DBMS\ExtTileStorages\t_ETS_Provider.pas',
  t_ETS_Tiles in 'TileStorage\DBMS\ExtTileStorages\t_ETS_Tiles.pas',
  u_ETS_Path in 'TileStorage\DBMS\ExtTileStorages\u_ETS_Path.pas',
  u_ETS_Tiles in 'TileStorage\DBMS\ExtTileStorages\u_ETS_Tiles.pas',
  c_GeoCoderGUIDSimple in 'GeoCoder\c_GeoCoderGUIDSimple.pas',
  i_GeoCoder in 'GeoCoder\i_GeoCoder.pas',
  i_GeoCoderList in 'GeoCoder\i_GeoCoderList.pas',
  u_GeoCoderBasic in 'GeoCoder\u_GeoCoderBasic.pas',
  u_GeoCoderBy2GIS in 'GeoCoder\u_GeoCoderBy2GIS.pas',
  u_GeoCoderByCoord in 'GeoCoder\u_GeoCoderByCoord.pas',
  u_GeoCoderByGoogle in 'GeoCoder\u_GeoCoderByGoogle.pas',
  u_GeoCoderByNavitel in 'GeoCoder\u_GeoCoderByNavitel.pas',
  u_GeoCoderByOSM in 'GeoCoder\u_GeoCoderByOSM.pas',
  u_GeoCoderByPolishMap in 'GeoCoder\u_GeoCoderByPolishMap.pas',
  u_GeoCoderByRosreestr in 'GeoCoder\u_GeoCoderByRosreestr.pas',
  u_GeoCoderByTXT in 'GeoCoder\u_GeoCoderByTXT.pas',
  u_GeoCoderByURL in 'GeoCoder\u_GeoCoderByURL.pas',
  u_GeoCoderByWikimapia in 'GeoCoder\u_GeoCoderByWikimapia.pas',
  u_GeoCoderByYandex in 'GeoCoder\u_GeoCoderByYandex.pas',
  u_GeoCodeResult in 'GeoCoder\u_GeoCodeResult.pas',
  u_GeoCoderListBase in 'GeoCoder\u_GeoCoderListBase.pas',
  u_GeoCoderListEntity in 'GeoCoder\u_GeoCoderListEntity.pas',
  u_GeoCoderListSimple in 'GeoCoder\u_GeoCoderListSimple.pas',
  u_GeoCoderLocalBasic in 'GeoCoder\u_GeoCoderLocalBasic.pas',
  u_GarbageCollectorThread in 'u_GarbageCollectorThread.pas',
  i_MapCalibration in 'i_MapCalibration.pas',
  u_MapCalibrationOzi in 'u_MapCalibrationOzi.pas',
  u_MapCalibrationDat in 'u_MapCalibrationDat.pas',
  u_MapCalibrationKml in 'u_MapCalibrationKml.pas',
  u_MapCalibrationTab in 'u_MapCalibrationTab.pas',
  u_MapCalibrationWorldFiles in 'u_MapCalibrationWorldFiles.pas',
  u_MapCalibrationListBasic in 'u_MapCalibrationListBasic.pas',
  i_ImportConfig in 'i_ImportConfig.pas',
  u_ImportConfig in 'u_ImportConfig.pas',
  i_ImportFile in 'i_ImportFile.pas',
  u_ImportByVectorLoader in 'MarksDb\u_ImportByVectorLoader.pas',
  u_ImportByFileExt in 'u_ImportByFileExt.pas',
  u_ExportMarks2KML in 'u_ExportMarks2KML.pas',
  i_UrlByCoordProvider in 'i_UrlByCoordProvider.pas',
  c_PathDetalizeProvidersGUID in 'c_PathDetalizeProvidersGUID.pas',
  i_PathDetalizeProvider in 'i_PathDetalizeProvider.pas',
  u_PathDetalizeProviderYourNavigation in 'u_PathDetalizeProviderYourNavigation.pas',
  u_PathDetalizeProviderCloudMade in 'u_PathDetalizeProviderCloudMade.pas',
  u_PathDetalizeProviderMailRu in 'u_PathDetalizeProviderMailRu.pas',
  i_PathDetalizeProviderList in 'i_PathDetalizeProviderList.pas',
  u_PathDetalizeProviderListEntity in 'u_PathDetalizeProviderListEntity.pas',
  u_PathDetalizeProviderListBase in 'u_PathDetalizeProviderListBase.pas',
  u_PathDetalizeProviderListSimple in 'u_PathDetalizeProviderListSimple.pas',
  u_UserInterfaceItemBase in 'u_UserInterfaceItemBase.pas',
  i_StaticTreeItem in 'i_StaticTreeItem.pas',
  u_StaticTreeItem in 'u_StaticTreeItem.pas',
  i_StaticTreeBuilder in 'i_StaticTreeBuilder.pas',
  u_StaticTreeBuilderBase in 'u_StaticTreeBuilderBase.pas',
  i_TreeChangeable in 'i_TreeChangeable.pas',
  u_TreeByPathDetalizeProviderList in 'u_TreeByPathDetalizeProviderList.pas',
  u_TreeChangeableBase in 'u_TreeChangeableBase.pas',
  i_MenuGeneratorByTree in 'i_MenuGeneratorByTree.pas',
  u_MenuGeneratorByStaticTreeSimple in 'u_MenuGeneratorByStaticTreeSimple.pas',
  u_TreeByMapActiveMapsSet in 'u_TreeByMapActiveMapsSet.pas',
  i_Sensor in 'i_Sensor.pas',
  i_SensorList in 'i_SensorList.pas',
  u_SensorListBase in 'u_SensorListBase.pas',
  u_SensorListStuped in 'u_SensorListStuped.pas',
  u_SensorViewTextTBXPanel in 'u_SensorViewTextTBXPanel.pas',
  u_SensorBase in 'u_SensorBase.pas',
  u_SensorFromGPSRecorderBase in 'u_SensorFromGPSRecorderBase.pas',
  u_SensorsFromGPSRecorder in 'u_SensorsFromGPSRecorder.pas',
  u_SensorTextFromNavToPoint in 'u_SensorTextFromNavToPoint.pas',
  u_SensorBatteryStatus in 'u_SensorBatteryStatus.pas',
  i_SensorViewListGenerator in 'i_SensorViewListGenerator.pas',
  u_SensorViewConfigSimple in 'u_SensorViewConfigSimple.pas',
  u_SensorViewListGeneratorStuped in 'u_SensorViewListGeneratorStuped.pas',
  i_MapTypes in 'i_MapTypes.pas',
  u_MapTypeBasic in 'u_MapTypeBasic.pas',
  u_MapTypeSet in 'u_MapTypeSet.pas',
  u_MapTypeSetChangeableSimple in 'u_MapTypeSetChangeableSimple.pas',
  u_MapTypeSetChangeableBySourceSetWithFilter in 'u_MapTypeSetChangeableBySourceSetWithFilter.pas',
  u_ActiveMapTBXItem in 'u_ActiveMapTBXItem.pas',
  u_MapTypeMenuItemsGeneratorBasic in 'u_MapTypeMenuItemsGeneratorBasic.pas',
  u_ActiveMapConfig in 'u_ActiveMapConfig.pas',
  u_ActiveMapSingleAbstract in 'u_ActiveMapSingleAbstract.pas',
  u_ActiveMapSingleSet in 'u_ActiveMapSingleSet.pas',
  u_ActiveMapsSet in 'u_ActiveMapsSet.pas',
  u_MainActiveMap in 'u_MainActiveMap.pas',
  u_ActivMapWithLayers in 'u_ActivMapWithLayers.pas',
  u_MainMapsConfig in 'u_MainMapsConfig.pas',
  i_ActiveMapsConfig in 'i_ActiveMapsConfig.pas',
  i_ViewPortState in 'i_ViewPortState.pas',
  u_MapViewPortState in 'u_MapViewPortState.pas',
  i_ShortCutSingleConfig in 'i_ShortCutSingleConfig.pas',
  u_ShortCutSingleConfig in 'u_ShortCutSingleConfig.pas',
  u_ShortcutManager in 'u_ShortcutManager.pas',
  i_LanguageListStatic in 'i_LanguageListStatic.pas',
  u_LanguageListStatic in 'u_LanguageListStatic.pas',
  i_LanguageManager in 'i_LanguageManager.pas',
  u_LanguageManager in 'u_LanguageManager.pas',
  i_StringConfigDataElement in 'i_StringConfigDataElement.pas',
  u_StringConfigDataElementWithDefBase in 'u_StringConfigDataElementWithDefBase.pas',
  u_StringConfigDataElementWithLanguage in 'u_StringConfigDataElementWithLanguage.pas',
  u_StringConfigDataElementWithDefByStringRec in 'u_StringConfigDataElementWithDefByStringRec.pas',
  u_StringConfigDataElementWithDefByGetText in 'u_StringConfigDataElementWithDefByGetText.pas',
  i_ProjConverter in 'i_ProjConverter.pas',
  u_ProjConverterFactory in 'u_ProjConverterFactory.pas',
  u_LanguagesEx in 'u_LanguagesEx.pas',
  u_LanguageTBXItem in 'u_LanguageTBXItem.pas',
  i_ImageResamplerFactory in 'i_ImageResamplerFactory.pas',
  u_ImageResamplerFactory in 'u_ImageResamplerFactory.pas',
  u_ImageResamplerFactoryListStatic in 'u_ImageResamplerFactoryListStatic.pas',
  u_ImageResamplerFactoryListStaticSimple in 'u_ImageResamplerFactoryListStaticSimple.pas',
  i_ImageResamplerConfig in 'i_ImageResamplerConfig.pas',
  u_ImageResamplerConfig in 'u_ImageResamplerConfig.pas',
  i_MainMemCacheConfig in 'i_MainMemCacheConfig.pas',
  u_MainMemCacheConfig in 'u_MainMemCacheConfig.pas',
  i_BasicMemCache in 'i_BasicMemCache.pas',
  i_MainGeoCoderConfig in 'i_MainGeoCoderConfig.pas',
  u_MainGeoCoderConfig in 'u_MainGeoCoderConfig.pas',
  i_KeyMovingConfig in 'i_KeyMovingConfig.pas',
  u_KeyMovingConfig in 'u_KeyMovingConfig.pas',
  i_StringByLanguage in 'i_StringByLanguage.pas',
  u_StringByLanguageWithStaticList in 'u_StringByLanguageWithStaticList.pas',
  i_LayerDrawConfig in 'i_LayerDrawConfig.pas',
  u_LayerDrawConfig in 'u_LayerDrawConfig.pas',
  i_MapTypeGUIConfig in 'i_MapTypeGUIConfig.pas',
  u_MapTypeGUIConfigStatic in 'u_MapTypeGUIConfigStatic.pas',
  u_MapTypeGUIConfig in 'u_MapTypeGUIConfig.pas',
  i_MapTypeHotKeyListStatic in 'i_MapTypeHotKeyListStatic.pas',
  u_MapTypeHotKeyListStatic in 'u_MapTypeHotKeyListStatic.pas',
  i_MapTypeGUIConfigList in 'i_MapTypeGUIConfigList.pas',
  u_MapTypeGUIConfigList in 'u_MapTypeGUIConfigList.pas',
  i_MainFormBehaviourByGPSConfig in 'i_MainFormBehaviourByGPSConfig.pas',
  u_MainFormBehaviourByGPSConfig in 'u_MainFormBehaviourByGPSConfig.pas',
  i_MainFormState in 'i_MainFormState.pas',
  u_MainFormState in 'u_MainFormState.pas',
  i_ValueToStringConverter in 'i_ValueToStringConverter.pas',
  u_ValueToStringConverter in 'u_ValueToStringConverter.pas',
  u_ValueToStringConverterConfig in 'u_ValueToStringConverterConfig.pas',
  i_StatBarConfig in 'i_StatBarConfig.pas',
  u_StatBarConfig in 'u_StatBarConfig.pas',
  i_NavigationToPoint in 'i_NavigationToPoint.pas',
  u_NavigationToPoint in 'u_NavigationToPoint.pas',
  i_MapLayerGPSTrackConfig in 'i_MapLayerGPSTrackConfig.pas',
  u_MapLayerGPSTrackConfig in 'u_MapLayerGPSTrackConfig.pas',
  i_CenterScaleConfig in 'i_CenterScaleConfig.pas',
  u_CenterScaleConfig in 'u_CenterScaleConfig.pas',
  i_ScaleLineConfig in 'i_ScaleLineConfig.pas',
  u_ScaleLineConfig in 'u_ScaleLineConfig.pas',
  i_LastSelectionLayerConfig in 'i_LastSelectionLayerConfig.pas',
  u_LastSelectionLayerConfig in 'u_LastSelectionLayerConfig.pas',
  i_LastSearchResultConfig in 'i_LastSearchResultConfig.pas',
  u_LastSearchResultConfig in 'u_LastSearchResultConfig.pas',
  u_PointsSetLayerConfig in 'u_PointsSetLayerConfig.pas',
  i_PolyLineLayerConfig in 'i_PolyLineLayerConfig.pas',
  u_PolyLineLayerConfig in 'u_PolyLineLayerConfig.pas',
  i_PolygonLayerConfig in 'i_PolygonLayerConfig.pas',
  u_PolygonLayerConfig in 'u_PolygonLayerConfig.pas',
  i_PointCaptionsLayerConfig in 'i_PointCaptionsLayerConfig.pas',
  i_CalcLineLayerConfig in 'i_CalcLineLayerConfig.pas',
  u_PointCaptionsLayerConfig in 'u_PointCaptionsLayerConfig.pas',
  u_CalcLineLayerConfig in 'u_CalcLineLayerConfig.pas',
  i_SelectionRectLayerConfig in 'i_SelectionRectLayerConfig.pas',
  u_SelectionRectLayerConfig in 'u_SelectionRectLayerConfig.pas',
  i_SelectionPolygonLayerConfig in 'i_SelectionPolygonLayerConfig.pas',
  u_SelectionPolygonLayerConfig in 'u_SelectionPolygonLayerConfig.pas',
  i_SelectionPolylineLayerConfig in 'i_SelectionPolylineLayerConfig.pas',
  u_SelectionPolylineLayerConfig in 'u_SelectionPolylineLayerConfig.pas',
  i_MarkPolygonLayerConfig in 'i_MarkPolygonLayerConfig.pas',
  u_MarkPolygonLayerConfig in 'u_MarkPolygonLayerConfig.pas',
  i_MarkPolyLineLayerConfig in 'i_MarkPolyLineLayerConfig.pas',
  u_MarkPolyLineLayerConfig in 'u_MarkPolyLineLayerConfig.pas',
  i_FillingMapColorer in 'i_FillingMapColorer.pas',
  u_FillingMapColorerSimple in 'u_FillingMapColorerSimple.pas',
  i_FillingMapLayerConfig in 'i_FillingMapLayerConfig.pas',
  u_FillingMapLayerConfigStatic in 'u_FillingMapLayerConfigStatic.pas',
  u_FillingMapLayerConfig in 'u_FillingMapLayerConfig.pas',
  u_FillingMapMapsConfig in 'u_FillingMapMapsConfig.pas',
  i_MapLayerGridsConfig in 'i_MapLayerGridsConfig.pas',
  u_BaseGridConfig in 'u_BaseGridConfig.pas',
  u_TileGridConfig in 'u_TileGridConfig.pas',
  u_GenShtabGridConfig in 'u_GenShtabGridConfig.pas',
  u_DegreeGridConfig in 'u_DegreeGridConfig.pas',
  u_MapLayerGridsConfig in 'u_MapLayerGridsConfig.pas',
  i_MarkerRingsConfig in 'i_MarkerRingsConfig.pas',
  u_MarkerRingsConfigStatic in 'u_MarkerRingsConfigStatic.pas',
  u_MarkerRingsConfig in 'u_MarkerRingsConfig.pas',
  i_MapLayerGPSMarkerConfig in 'i_MapLayerGPSMarkerConfig.pas',
  u_MapLayerGPSMarkerConfig in 'u_MapLayerGPSMarkerConfig.pas',
  u_MapLayerSearchResults in 'MapLayers\u_MapLayerSearchResults.pas',
  i_BitmapPostProcessingConfig in 'i_BitmapPostProcessingConfig.pas',
  u_BitmapPostProcessingConfig in 'u_BitmapPostProcessingConfig.pas',
  i_BitmapPostProcessing in 'i_BitmapPostProcessing.pas',
  u_BitmapPostProcessing in 'u_BitmapPostProcessing.pas',
  u_BitmapPostProcessingChangeableByConfig in 'u_BitmapPostProcessingChangeableByConfig.pas',
  i_MapZoomingConfig in 'i_MapZoomingConfig.pas',
  u_MapZoomingConfig in 'u_MapZoomingConfig.pas',
  i_MapMovingConfig in 'i_MapMovingConfig.pas',
  u_MapMovingConfig in 'u_MapMovingConfig.pas',
  i_MainFormConfig in 'i_MainFormConfig.pas',
  u_MainFormMainConfig in 'u_MainFormMainConfig.pas',
  u_MainFormConfig in 'u_MainFormConfig.pas',
  u_MainFormLayersConfig in 'u_MainFormLayersConfig.pas',
  i_MapLayerNavToPointMarkerConfig in 'i_MapLayerNavToPointMarkerConfig.pas',
  u_MapLayerNavToPointMarkerConfig in 'u_MapLayerNavToPointMarkerConfig.pas',
  i_DownloadUIConfig in 'i_DownloadUIConfig.pas',
  u_DownloadUIConfig in 'u_DownloadUIConfig.pas',
  i_WindowPositionConfig in 'i_WindowPositionConfig.pas',
  u_WindowPositionConfig in 'u_WindowPositionConfig.pas',
  i_MainWindowPosition in 'i_MainWindowPosition.pas',
  u_MainWindowPositionConfig in 'u_MainWindowPositionConfig.pas',
  u_MainWindowToolbarsLock in 'u_MainWindowToolbarsLock.pas',
  i_SelectionRect in 'i_SelectionRect.pas',
  u_SelectionRect in 'u_SelectionRect.pas',
  i_PointOnMapEdit in 'i_PointOnMapEdit.pas',
  u_PointOnMapEdit in 'u_PointOnMapEdit.pas',
  i_LineOnMapEdit in 'i_LineOnMapEdit.pas',
  u_LineOnMapEdit in 'u_LineOnMapEdit.pas',
  i_GlobalAppConfig in 'i_GlobalAppConfig.pas',
  u_GlobalAppConfig in 'u_GlobalAppConfig.pas',
  i_StartUpLogoConfig in 'i_StartUpLogoConfig.pas',
  u_StartUpLogoConfig in 'u_StartUpLogoConfig.pas',
  i_GlobalDownloadConfig in 'i_GlobalDownloadConfig.pas',
  u_GlobalDownloadConfig in 'u_GlobalDownloadConfig.pas',
  i_GlobalInternetState in 'i_GlobalInternetState.pas',
  i_GlobalViewMainConfig in 'i_GlobalViewMainConfig.pas',
  u_GlobalViewMainConfig in 'u_GlobalViewMainConfig.pas',
  u_IeEmbeddedProtocolRegistration in 'u_IeEmbeddedProtocolRegistration.pas',
  u_IeEmbeddedProtocolFactory in 'u_IeEmbeddedProtocolFactory.pas',
  u_IeEmbeddedProtocol in 'u_IeEmbeddedProtocol.pas',
  u_InternalDomainInfoProviderList in 'u_InternalDomainInfoProviderList.pas',
  i_InternalDomainInfoProvider in 'i_InternalDomainInfoProvider.pas',
  u_InternalDomainInfoProviderByMapTypeList in 'u_InternalDomainInfoProviderByMapTypeList.pas',
  u_InternalDomainInfoProviderByDataProvider in 'u_InternalDomainInfoProviderByDataProvider.pas',
  u_InternalDomainInfoProviderByMarksSystem in 'u_InternalDomainInfoProviderByMarksSystem.pas',
  u_InternalDomainInfoProviderByMapData in 'u_InternalDomainInfoProviderByMapData.pas',
  u_InternalDomainInfoProviderByLastSearchResults in 'u_InternalDomainInfoProviderByLastSearchResults.pas',
  u_InternalDomainInfoProviderByTileStorageOptions in 'u_InternalDomainInfoProviderByTileStorageOptions.pas',
  i_InternalDomainOptions in 'i_InternalDomainOptions.pas',
  i_SimpleHttpDownloader in 'i_SimpleHttpDownloader.pas',
  u_SimpleHttpDownloader in 'u_SimpleHttpDownloader.pas',
  i_Bitmap32Static in 'i_Bitmap32Static.pas',
  i_Bitmap32StaticFactory in 'i_Bitmap32StaticFactory.pas',
  u_Bitmap32StaticFactory in 'u_Bitmap32StaticFactory.pas',
  u_Bitmap32ByStaticBitmap in 'u_Bitmap32ByStaticBitmap.pas',
  u_ObjectPoolBitmap32Standart in 'u_ObjectPoolBitmap32Standart.pas',
  u_BitmapChangeableFaked in 'u_BitmapChangeableFaked.pas',
  i_BitmapGeo in 'i_BitmapGeo.pas',
  u_BitmapGeo in 'u_BitmapGeo.pas',
  i_BitmapMarker in 'i_BitmapMarker.pas',
  u_BitmapMarker in 'u_BitmapMarker.pas',
  i_MarkerDrawable in 'i_MarkerDrawable.pas',
  u_MarkerDrawableComplex in 'u_MarkerDrawableComplex.pas',
  u_MarkerDrawableSimpleAbstract in 'u_MarkerDrawableSimpleAbstract.pas',
  u_MarkerDrawableSimpleArrow in 'u_MarkerDrawableSimpleArrow.pas',
  u_MarkerDrawableSimpleCross in 'u_MarkerDrawableSimpleCross.pas',
  u_MarkerDrawableSimpleSquare in 'u_MarkerDrawableSimpleSquare.pas',
  u_MarkerDrawableCenterScale in 'u_MarkerDrawableCenterScale.pas',
  u_MarkerDrawableByBitmapMarker in 'u_MarkerDrawableByBitmapMarker.pas',
  u_MarkerDrawableByBitmap32Static in 'u_MarkerDrawableByBitmap32Static.pas',
  u_MarkerDrawableWithDirectionByBitmapMarker in 'u_MarkerDrawableWithDirectionByBitmapMarker.pas',
  u_MarkerDrawableChangeableFaked in 'u_MarkerDrawableChangeableFaked.pas',
  u_MarkerDrawableChangeableSimple in 'u_MarkerDrawableChangeableSimple.pas',
  i_MarkerProviderForVectorItem in 'i_MarkerProviderForVectorItem.pas',
  u_MarkerProviderForVectorItemFixedMarker in 'u_MarkerProviderForVectorItemFixedMarker.pas',
  u_MarkerProviderForVectorItemForMarkPoints in 'u_MarkerProviderForVectorItemForMarkPoints.pas',
  u_MarkerProviderForVectorItemWithCache in 'u_MarkerProviderForVectorItemWithCache.pas',
  i_MarkerSimpleConfig in 'i_MarkerSimpleConfig.pas',
  u_MarkerSimpleConfigStatic in 'u_MarkerSimpleConfigStatic.pas',
  u_MarkerSimpleConfig in 'u_MarkerSimpleConfig.pas',
  i_MarkerFromFileConfig in 'i_MarkerFromFileConfig.pas',
  u_MarkerFromFileConfigStatic in 'u_MarkerFromFileConfigStatic.pas',
  u_MarkerFromFileConfig in 'u_MarkerFromFileConfig.pas',
  i_ProjectedDrawableElement in 'i_ProjectedDrawableElement.pas',
  u_ProjectedDrawableElementByPolygon in 'u_ProjectedDrawableElementByPolygon.pas',
  i_MessageHandler in 'i_MessageHandler.pas',
  u_KeyMovingHandler in 'u_KeyMovingHandler.pas',
  i_MouseState in 'i_MouseState.pas',
  i_MouseHandler in 'i_MouseHandler.pas',
  u_MouseState in 'u_MouseState.pas',
  i_GPSRecorder in 'GPS\i_GPSRecorder.pas',
  u_GPSRecorder in 'GPS\u_GPSRecorder.pas',
  u_GpsTrackRecorder in 'GPS\u_GpsTrackRecorder.pas',
  i_GPS in 'GPS\i_GPS.pas',
  i_GPSPositionFactory in 'GPS\i_GPSPositionFactory.pas',
  i_GPSModule in 'GPS\i_GPSModule.pas',
  i_GPSModuleByCOM in 'GPS\i_GPSModuleByCOM.pas',
  i_GPSModuleByCOMFactory in 'GPS\i_GPSModuleByCOMFactory.pas',
  i_GPSModuleByCOMPortSettings in 'GPS\i_GPSModuleByCOMPortSettings.pas',
  i_GPSModuleByCOMPortConfig in 'GPS\i_GPSModuleByCOMPortConfig.pas',
  u_GPSModuleByCOMPortConfig in 'GPS\u_GPSModuleByCOMPortConfig.pas',
  u_GPSModuleByCOMPortSettings in 'GPS\u_GPSModuleByCOMPortSettings.pas',
  i_SatellitesInViewMapDraw in 'i_SatellitesInViewMapDraw.pas',
  u_SatellitesInViewMapDrawSimple in 'u_SatellitesInViewMapDrawSimple.pas',
  u_InetFunc in 'u_InetFunc.pas',
  i_DebugInfoWindow in 'i_DebugInfoWindow.pas',
  u_DebugInfoWindow in 'u_DebugInfoWindow.pas',
  i_MapSvcScanConfig in 'MapSvcScan\i_MapSvcScanConfig.pas',
  u_MapSvcScanConfig in 'MapSvcScan\u_MapSvcScanConfig.pas',
  i_MapSvcScanStorage in 'MapSvcScan\i_MapSvcScanStorage.pas',
  u_MapSvcScanStorage in 'MapSvcScan\u_MapSvcScanStorage.pas',
  u_AvailPicsAbstract in 'MapSvcScan\u_AvailPicsAbstract.pas',
  u_AvailPicsBing in 'MapSvcScan\u_AvailPicsBing.pas',
  u_AvailPicsNMC in 'MapSvcScan\u_AvailPicsNMC.pas',
  u_AvailPicsDG in 'MapSvcScan\u_AvailPicsDG.pas',
  u_AvailPicsDD in 'MapSvcScan\u_AvailPicsDD.pas',
  u_AvailPicsDG2 in 'MapSvcScan\u_AvailPicsDG2.pas',
  u_AvailPicsTerra in 'MapSvcScan\u_AvailPicsTerra.pas',
  u_AvailPicsESRI in 'MapSvcScan\u_AvailPicsESRI.pas',
  u_AvailPicsGeoFuse in 'MapSvcScan\u_AvailPicsGeoFuse.pas',
  u_AvailPicsRosCosmos in 'MapSvcScan\u_AvailPicsRosCosmos.pas',
  u_AvailPicsKosmosnimki in 'MapSvcScan\u_AvailPicsKosmosnimki.pas',
  i_InternalBrowser in 'i_InternalBrowser.pas',
  u_InternalBrowserByForm in 'u_InternalBrowserByForm.pas',
  i_InvisibleBrowser in 'i_InvisibleBrowser.pas',
  u_InvisibleBrowserByFormSynchronize in 'u_InvisibleBrowserByFormSynchronize.pas',
  i_GPSConfig in 'GPS\i_GPSConfig.pas',
  u_GPSConfig in 'GPS\u_GPSConfig.pas',
  u_GPSSatelliteInfo in 'GPS\u_GPSSatelliteInfo.pas',
  u_GPSSatellitesInView in 'GPS\u_GPSSatellitesInView.pas',
  u_GPSPositionStatic in 'GPS\u_GPSPositionStatic.pas',
  u_GPSPositionFactory in 'GPS\u_GPSPositionFactory.pas',
  u_GPSModuleAbstract in 'GPS\u_GPSModuleAbstract.pas',
  u_GPSModuleByVSAGPS in 'GPS\u_GPSModuleByVSAGPS.pas',
  u_GPSModuleFactoryByVSAGPS in 'GPS\u_GPSModuleFactoryByVSAGPS.pas',
  i_MapTypeConfigModalEdit in 'i_MapTypeConfigModalEdit.pas',
  u_MapTypeConfigModalEditByForm in 'u_MapTypeConfigModalEditByForm.pas',
  i_ShortCutModalEdit in 'i_ShortCutModalEdit.pas',
  u_ShortCutModalEditByForm in 'u_ShortCutModalEditByForm.pas',
  i_RegionProcessParamsFrame in 'RegionProcess\i_RegionProcessParamsFrame.pas',
  u_ExportProviderAbstract in 'RegionProcess\u_ExportProviderAbstract.pas',
  u_SearchResults in 'u_SearchResults.pas',
  u_BitmapFunc in 'u_BitmapFunc.pas',
  frm_CacheManager in 'CacheManager\frm_CacheManager.pas' {frmCacheManager},
  frm_ProgressCacheConvrter in 'CacheManager\frm_ProgressCacheConvrter.pas' {frmProgressCacheConvrter},
  u_ThreadCacheConverter in 'CacheManager\u_ThreadCacheConverter.pas',
  u_ThreadCacheManagerAbstract in 'CacheManager\u_ThreadCacheManagerAbstract.pas',
  i_CacheConverterProgressInfo in 'CacheManager\i_CacheConverterProgressInfo.pas',
  u_CacheConverterProgressInfo in 'CacheManager\u_CacheConverterProgressInfo.pas',
  fr_Export in 'RegionProcess\fr_Export.pas' {frExport: TFrame},
  fr_ExportYaMobileV3 in 'RegionProcess\fr_ExportYaMobileV3.pas' {frExportYaMobileV3: TFrame},
  u_ExportProviderYaMobileV3 in 'RegionProcess\u_ExportProviderYaMobileV3.pas',
  fr_ExportYaMobileV4 in 'RegionProcess\fr_ExportYaMobileV4.pas' {frExportYaMobileV4: TFrame},
  u_ExportProviderYaMobileV4 in 'RegionProcess\u_ExportProviderYaMobileV4.pas',
  fr_ExportGEKml in 'RegionProcess\fr_ExportGEKml.pas' {frExportGEKml: TFrame},
  u_ExportProviderGEKml in 'RegionProcess\u_ExportProviderGEKml.pas',
  fr_ExportRMapsSQLite in 'RegionProcess\fr_ExportRMapsSQLite.pas' {frExportRMapsSQLite: TFrame},
  u_ExportProviderRMapsSQLite in 'RegionProcess\u_ExportProviderRMapsSQLite.pas',
  fr_ExportIPhone in 'RegionProcess\fr_ExportIPhone.pas' {frExportIPhone: TFrame},
  u_ExportProviderIPhone in 'RegionProcess\u_ExportProviderIPhone.pas',
  fr_ExportAUX in 'RegionProcess\fr_ExportAUX.pas' {frExportAUX: TFrame},
  u_ExportProviderAUX in 'RegionProcess\u_ExportProviderAUX.pas',
  fr_ExportToFileCont in 'RegionProcess\fr_ExportToFileCont.pas' {frExportToFileCont: TFrame},
  u_ExportProviderZip in 'RegionProcess\u_ExportProviderZip.pas',
  u_ExportProviderTar in 'RegionProcess\u_ExportProviderTar.pas',
  u_ExportProviderJNX in 'RegionProcess\u_ExportProviderJNX.pas',
  u_ThreadExportToJNX in 'RegionProcess\u_ThreadExportToJNX.pas',
  fr_ExportToJNX in 'RegionProcess\fr_ExportToJNX.pas' {frExportToJNX: TFrame},
  fr_ExportToOgf2 in 'RegionProcess\fr_ExportToOgf2.pas' {frExportToOgf2: TFrame},
  u_ExportProviderOgf2 in 'RegionProcess\u_ExportProviderOgf2.pas',
  u_ThreadExportToOgf2 in 'RegionProcess\u_ThreadExportToOgf2.pas',
  u_ExportProviderCE in 'RegionProcess\u_ExportProviderCE.pas',
  u_ThreadExportToCE in 'RegionProcess\u_ThreadExportToCE.pas',
  fr_ExportToCE in 'RegionProcess\fr_ExportToCE.pas' {frExportToCE: TFrame},
  fr_TilesDelete in 'RegionProcess\fr_TilesDelete.pas' {frTilesDelete: TFrame},
  u_ProviderTilesDelete in 'RegionProcess\u_ProviderTilesDelete.pas',
  fr_TilesGenPrev in 'RegionProcess\fr_TilesGenPrev.pas' {frTilesGenPrev: TFrame},
  u_ProviderTilesGenPrev in 'RegionProcess\u_ProviderTilesGenPrev.pas',
  fr_TilesCopy in 'RegionProcess\fr_TilesCopy.pas' {frTilesCopy: TFrame},
  u_ProviderTilesCopy in 'RegionProcess\u_ProviderTilesCopy.pas',
  fr_MapCombine in 'RegionProcess\fr_MapCombine.pas' {frMapCombine: TFrame},
  fr_Combine in 'RegionProcess\fr_Combine.pas' {frCombine: TFrame},
  u_ProviderMapCombineBMP in 'RegionProcess\u_ProviderMapCombineBMP.pas',
  u_ProviderMapCombineJP2 in 'RegionProcess\u_ProviderMapCombineJP2.pas',
  u_ProviderMapCombineECW in 'RegionProcess\u_ProviderMapCombineECW.pas',
  u_ProviderMapCombineJPG in 'RegionProcess\u_ProviderMapCombineJPG.pas',
  u_ProviderMapCombinePNG in 'RegionProcess\u_ProviderMapCombinePNG.pas',
  u_ProviderMapCombineKMZ in 'RegionProcess\u_ProviderMapCombineKMZ.pas',
  u_ProviderMapCombine in 'RegionProcess\u_ProviderMapCombine.pas',
  fr_TilesDownload in 'RegionProcess\fr_TilesDownload.pas' {frTilesDownload: TFrame},
  u_ProviderTilesDownload in 'RegionProcess\u_ProviderTilesDownload.pas',
  fr_ShortCutList in 'fr_ShortCutList.pas' {frShortCutList: TFrame},
  fr_MapsList in 'fr_MapsList.pas' {frMapsList: TFrame},
  fr_GPSConfig in 'fr_GPSConfig.pas' {frGPSConfig: TFrame},
  fr_GpsSatellites in 'fr_GpsSatellites.pas' {frGpsSatellites: TFrame},
  fr_MarkCategorySelectOrAdd in 'MarksDb\GUI\fr_MarkCategorySelectOrAdd.pas' {frMarkCategorySelectOrAdd: TFrame},
  fr_MarksGeneralOptions in 'MarksDb\GUI\fr_MarksGeneralOptions.pas' {frMarksGeneralOptions: TFrame},
  fr_MarkDescription in 'MarksDb\GUI\fr_MarkDescription.pas' {frMarkDescription: TFrame},
  fr_SelectedPicture in 'fr_SelectedPicture.pas' {frSelectedPicture: TFrame},
  fr_PictureSelectFromList in 'fr_PictureSelectFromList.pas' {frPictureSelectFromList: TFrame},
  fr_LonLat in 'fr_LonLat.pas' {frLonLat: TFrame},
  fr_SearchResultsItem in 'fr_SearchResultsItem.pas' {frSearchResultsItem: TFrame},
  frm_Main in 'frm_Main.pas' {frmMain},
  frm_GoTo in 'frm_GoTo.pas' {frmGoTo},
  frm_DebugInfo in 'frm_DebugInfo.pas' {frmDebugInfo},
  frm_About in 'frm_About.pas' {frmAbout},
  frm_Settings in 'frm_Settings.pas' {frmSettings},
  frm_MapLayersOptions in 'frm_MapLayersOptions.pas' {frmMapLayersOptions},
  frm_RegionProcess in 'RegionProcess\frm_RegionProcess.pas' {frmRegionProcess},
  frm_ProgressDownload in 'RegionProcess\frm_ProgressDownload.pas' {frmProgressDownload},
  frm_InvisibleBrowser in 'frm_InvisibleBrowser.pas' {frmInvisibleBrowser},
  frm_MarkEditPoint in 'MarksDb\GUI\frm_MarkEditPoint.pas' {frmMarkEditPoint},
  frm_MarkInfo in 'frm_MarkInfo.pas' {frmMarkInfo},
  frm_ProgressSimple in 'RegionProcess\frm_ProgressSimple.pas' {frmProgressSimple},
  frm_StartLogo in 'frm_StartLogo.pas' {frmStartLogo},
  frm_LonLatRectEdit in 'frm_LonLatRectEdit.pas' {frmLonLatRectEdit},
  frm_IntrnalBrowser in 'frm_IntrnalBrowser.pas' {frmIntrnalBrowser},
  frm_MarkEditPath in 'MarksDb\GUI\frm_MarkEditPath.pas' {frmMarkEditPath},
  frm_MarkEditPoly in 'MarksDb\GUI\frm_MarkEditPoly.pas' {frmMarkEditPoly},
  frm_MapTypeEdit in 'frm_MapTypeEdit.pas' {frmMapTypeEdit},
  frm_MarksExplorer in 'MarksDb\GUI\frm_MarksExplorer.pas' {frmMarksExplorer},
  frm_ImportConfigEdit in 'MarksDb\GUI\frm_ImportConfigEdit.pas' {frmImportConfigEdit},
  frm_MarkCategoryEdit in 'MarksDb\GUI\frm_MarkCategoryEdit.pas' {frmMarkCategoryEdit},
  frm_DGAvailablePic in 'MapSvcScan\frm_DGAvailablePic.pas' {frmDGAvailablePic},
  frm_MarksMultiEdit in 'MarksDb\GUI\frm_MarksMultiEdit.pas' {frmMarksMultiEdit},
  frm_ShortCutEdit in 'frm_ShortCutEdit.pas' {frmShortCutEdit};

{$R .\Resources\VersionInfo.res}
{$R .\Resources\MainIcon.res}
{$R .\Resources\Common.res}

{$SetPEFlags IMAGE_FILE_RELOCS_STRIPPED}

begin
  SetCurrentThreadName('ApplicationMainThread');
  if TBaseInterfacedObject = TBaseInterfacedObjectDebug then begin
    TBaseInterfacedObjectDebug.InitCounters;
  end;
  GState := TGlobalState.Create;
  try
    Application.Initialize;
    Application.MainFormOnTaskBar := True;
    Application.Title := SAS_STR_ApplicationTitle;
    TfrmStartLogo.ShowLogo(
      GState.Config.LanguageManager,
      GState.AppStartedNotifier,
      GState.ContentTypeManager,
      GState.MainConfigProvider,
      GState.Config.StartUpLogoConfig
    );
    try
      GState.LoadConfig;
    except
      on E: Exception do begin
        Application.ShowException(E);
        Exit;
      end;
    end;
    Application.HelpFile := '';
    Application.CreateForm(TfrmMain, frmMain);
    GState.StartExceptionTracking;
    try
      Application.Run;
    finally
      GState.StopExceptionTracking;
    end;
  finally
    GState.Free;
  end;
end.
